include masm32rt.inc


code_macro EQU "[size=10pt][b][color=Maroon]#[/color][/b][/size]"
ctrl_macro EQU "[size=10pt][b][color=Navy]#[/color][/b][/size]"
hlp_macro  EQU "[size=10pt][b][color=Purple]#[/color][/b][/size]"

kw_cntr = 0
add_kw macro keyword:req,new_txt:=<"[size=10pt][b][color=Maroon]#[/color][/b][/size]">
	
	IFNDEF KeyWord
		KeyWord segment READONLY
			KeyWords LABEL PVOID
		KeyWord ends
	ENDIF
	
	sz_kword segment READONLY
		@CatStr(<kywrd>,%kw_cntr) db @CatStr(<!">,keyword,<!">),0
		ak_pos INSTR 1,<&new_txt>,<#>
		ak_A SUBSTR <&new_txt>,1,ak_pos-1
		ak_B SUBSTR <&new_txt>,ak_pos+1
		ak_C CATSTR ak_A,<&keyword>,ak_B
		@CatStr(<replTxt>,%kw_cntr) db ak_C,0
	sz_kword ends
	
	KeyWord segment READONLY
		PVOID OFFSET @CatStr(<kywrd>,%kw_cntr),OFFSET @CatStr(<replTxt>,%kw_cntr)
	KeyWord ends
	kw_cntr = kw_cntr + 1
endm

.data

	sz_prefix 	db "[font=terminal]"
				db 0
	sz_suffix 	db "[/font]"
				db 0

	add_kw <fSlv>,%code_macro
	add_kw <fSlv4>,%code_macro
	add_kw <fSlv8>,%code_macro
	add_kw <fSlv10>,%code_macro
	add_kw <@fSlv4>,%code_macro
	add_kw <@fSlv8>,%code_macro
	add_kw <@fSlvI>,%code_macro
	add_kw <fEQ>,%code_macro
	add_kw <faEQ>,%code_macro
	add_kw <fNE>,%code_macro
	add_kw <fLT>,%code_macro
	add_kw <fGT>,%code_macro
	add_kw <fGE>,%code_macro
	add_kw <fLE>,%code_macro
	
	add_kw <fSlvTLS>,%ctrl_macro
	add_kw <fSlvSetPrecision>,%ctrl_macro
	add_kw <fSlvRegConst>,%ctrl_macro
	add_kw <fSlvSetFlags>,%ctrl_macro
	add_kw <fSlvRemoveFlags>,%ctrl_macro
	add_kw <fSlvResetFlags>,%ctrl_macro
	add_kw <fSlvRegExpr>,%ctrl_macro
	add_kw <fSlvStatistics>,%ctrl_macro
	
	add_kw <fpuSetPrecision>,%hlp_macro
	add_kw <ldl>,%hlp_macro
				
	KeyWord segment READONLY
		PCHAR 0,0
	KeyWord ends

; fSlv eax = @fSlv4() + y

.code
main proc
LOCAL cb:DWORD
LOCAL cc:DWORD
LOCAL hMem:HGLOBAL
LOCAL pos:SDWORD
LOCAL pRepl:HGLOBAL
LOCAL cc_new:DWORD

	.if rv(OpenClipboard,0)
		.if rv(GetClipboardData,CF_TEXT)
			mov hMem,eax
			mov esi,rv(GlobalLock,hMem)	;
			mov cb,rv(GlobalSize,hMem)	;
			.if cb
				mov edi,alloc(cb)
				.if edi
					invoke MemCopy,esi,edi,cb	;
					invoke GlobalUnlock,hMem	;
					invoke CloseClipboard		;
				.else
					jmp @2
				.endif
			.else
				invoke GlobalUnlock,hMem
				jmp @2
			.endif
		.else
		@2:	invoke CloseClipboard
			jmp @1
		.endif
	.else	
	@1:	invoke MessageBeep,0FFFFFFFFh
		exit
	.endif
	mov esi,edi

	xor ecx,ecx
	xor edx,edx
	.while CHAR ptr [esi+ecx] && ecx < cb
		.if CHAR ptr [esi+ecx] == 9
			lea edx,[edx+3]
		.else
			lea edx,[edx+1]
		.endif
		
		lea ecx,[ecx+1]
	.endw
	mov eax,cb
	lea eax,[eax+edx+1]
	mov cc,eax

	mov edi,alloc(cc)

	xor ecx,ecx
	xor edx,edx
	xor ebx,ebx
	.while CHAR ptr [esi+ecx] && ecx < cb
		.if CHAR ptr [esi+ecx] == 13 && CHAR ptr [esi+ecx+1] == 10
			mov ebx,-2
		.endif
		.if CHAR ptr [esi+ecx] == 9
			mov eax,ebx
			and eax,3
			.if eax == 0
				mov CHAR ptr [edi+edx+0],20h
				mov CHAR ptr [edi+edx+1],20h
				mov CHAR ptr [edi+edx+2],20h
				mov CHAR ptr [edi+edx+3],20h
				lea edx,[edx+3]
				lea ebx,[ebx+3]
			.elseif eax == 1
				mov CHAR ptr [edi+edx+0],20h
				mov CHAR ptr [edi+edx+1],20h
				mov CHAR ptr [edi+edx+2],20h
				lea edx,[edx+2]
				lea ebx,[ebx+2]
			.elseif eax == 2
				mov CHAR ptr [edi+edx+0],20h
				mov CHAR ptr [edi+edx+1],20h
				lea edx,[edx+1]
				lea ebx,[ebx+1]
			.else
				mov CHAR ptr [edi+edx+0],20h
			.endif
		.else
			movzx eax,CHAR ptr [esi+ecx]
			mov CHAR ptr [edi+edx],al
		.endif
		lea edx,[edx+1]
		lea ecx,[ecx+1]
		lea ebx,[ebx+1]
	.endw
	mov CHAR ptr [edi+edx],0
	
	free esi
	mov esi,edi
	
	lea ebx,KeyWords
	xor edi,edi
	
	mov eax,cc
	lea eax,[eax*8]
	mov pRepl,alloc(eax)
	mov cc_new,len(esi)
	inc cc_new
	add cc_new,SIZEOF sz_prefix + SIZEOF sz_suffix
	
	.while PCHAR ptr [ebx]
		
		mov pos,1
		mov cb,len(PCHAR ptr [ebx])
		.while 1
			.break .if SDWORD ptr rv(InString,pos,esi,PCHAR ptr [ebx]) <= 0
			mov pos,eax
			lea edx,[esi+eax-1]
			.if esi > esi
				movzx eax,CHAR ptr [edx-1]
				.if !(	eax == 9   ||\
								eax == 20h ||\
								eax == '+' ||\
								eax == '-' ||\
								eax == '*' ||\
								eax == '/' ||\
								eax == '|' ||\
								eax == '&' ||\
								eax == '<' ||\
								eax == '>' ||\
								eax == ',' ||\
								eax == ':' ||\
								eax == '=' ||\
								eax == '(' ||\
								eax == ')' ||\
								eax == '!' ||\
								eax == ';')
					inc pos
					.continue
				.endif
			.endif
			mov eax,pos
			lea edx,[esi+eax-1]
			add edx,cb
			movzx eax,CHAR ptr [edx]
			.if eax
				.if !(	eax == 9   ||\
								eax == 20h ||\
								eax == '+' ||\
								eax == '-' ||\
								eax == '*' ||\
								eax == '/' ||\
								eax == '|' ||\
								eax == '&' ||\
								eax == '<' ||\
								eax == '>' ||\
								eax == ',' ||\
								eax == ':' ||\
								eax == '=' ||\
								eax == '(' ||\
								eax == ')' ||\
								eax == ';')
					inc pos
					.continue
				.endif
			.endif
			mov edx,pRepl
			mov eax,pos
			lea eax,[eax-1]
			m2m PCHAR ptr [edx+eax*8],PCHAR ptr [ebx+4]
			m2m PCHAR ptr [edx+eax*8+4],cb
			mov edx,len(PCHAR ptr [ebx+4])
			sub edx,cb
			add cc_new,edx
			inc pos
		.endw
		lea ebx,[ebx+8]
	.endw
	
	mov eax,pRepl
	mov edx,cc_new
	
	mov hMem,rv(GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,cc_new)
	mov edi,rv(GlobalLock,hMem)
	
	mov ebx,pRepl
	xor ecx,ecx
	mov edx,OFFSEt sz_prefix
	.while CHAR ptr [edx]
		movzx eax,CHAR ptr [edx]
		mov CHAR ptr [edi],al
		lea edi,[edi+1]
		lea edx,[edx+1]
	.endw
	.while CHAR ptr [esi+ecx]
		.if !PCHAR ptr [ebx+ecx*8]
			movzx eax,CHAR ptr [esi+ecx]
			mov CHAR ptr [edi],al
			lea edi,[edi+1]
			lea ecx,[ecx+1]
		.else	
			mov edx,PCHAR ptr [ebx+ecx*8]
			add ecx,DWORD ptr [ebx+ecx*8+4]
			.while CHAR ptr [edx]
				movzx eax,CHAR ptr [edx]
				mov CHAR ptr [edi],al
				lea edi,[edi+1]
				lea edx,[edx+1]
			.endw
		.endif
	.endw
	mov edx,OFFSEt sz_suffix
	.while CHAR ptr [edx]
		movzx eax,CHAR ptr [edx]
		mov CHAR ptr [edi],al
		lea edi,[edi+1]
		lea edx,[edx+1]
	.endw
	mov CHAR ptr [edi],0
	
	
	invoke GlobalUnlock,hMem
	invoke OpenClipboard,0

	invoke EmptyClipboard
	invoke SetClipboardData,CF_TEXT,hMem
	invoke CloseClipboard
	
	exit
	
main endp
end main